
import javax.microedition.lcdui.*;

// 
public class GeneralForm extends Form implements CommandListener
{
    private Command cancelCmd = new Command(I18N.getThisI18N().getViewStr("Cancel"), Command.BACK, 2); // 
    private Command saveCmd = new Command(I18N.getThisI18N().getViewStr("Save"), Command.OK, 1); // 
    private String [] extensionString = {I18N.getThisI18N().getViewStr("Yes")};
    private ChoiceGroup extension = new ChoiceGroup(I18N.getThisI18N().getViewStr("Confirm on Exit"), Choice.MULTIPLE, extensionString, null);  //   ()
    private StringItem stringItem = new StringItem (I18N.getThisI18N().getViewStr("Tips"), I18N.getThisI18N().getAlertText(10));    
    
    public GeneralForm()
    {
        super(I18N.getThisI18N().getViewStr("Settings"));
        append (extension);
        append (stringItem);
        extension.setSelectedIndex(0, MiniPadRus.getInstance().autoExit);
        addCommand(cancelCmd);
        addCommand(saveCmd);
        setCommandListener(this); 
    }

    public void commandAction(Command c, Displayable d)
    {
        //  
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        //   
        Display display = Display.getDisplay(myMIDlet);  
         
        //  
        if (c == saveCmd)
        {
            SettingsList.getInstance().changeSet = true;
            //   
            if (extension.isSelected(0))
            {
                 MiniPadRus.getInstance().autoExit = true;
            }
            else 
            {
                 MiniPadRus.getInstance().autoExit = false;
             }
        }
        
        //    
        display.setCurrent(SettingsList.getInstance());         
    }
    
}
