import javax.microedition.lcdui.*;

public class SearchResult extends List implements CommandListener
{

    private static SearchResult instance = null;
    private static Command allViewCmd = new Command(I18N.getThisI18N().getViewStr("View all Records"), Command.SCREEN, 2); //  -         
    public static Command deleteCmd = new Command(I18N.getThisI18N().getViewStr("Delete"), Command.SCREEN, 3);
    private static Command renameCmd = new Command(I18N.getThisI18N().getViewStr("Rename"), Command.SCREEN, 4);    
    private static Command backCmd = new Command(I18N.getThisI18N().getViewStr("Back"), Command.BACK, 7); //  -     
    private int [] itogo; //          

    public SearchResult ()
    {   
        super(I18N.getThisI18N().getViewStr("Founds: "), Choice.IMPLICIT);        
        addCommand(deleteCmd);
        addCommand(renameCmd);
        addCommand(allViewCmd);
        addCommand(backCmd);
        setCommandListener(this);
        itogo = new int [1];
        instance = this;        
    }
    
    public static SearchResult getInstance() 
    { 
        return instance; 
    }

    
    public void addNewResult(String addS, int numberAddS, int kolvoResult)
    {
                append(addS, null);
                
                if ( kolvoResult == 1) itogo [0] = numberAddS;
                else
                {
                    int [] tempItogo = new int [kolvoResult];
                    System.arraycopy(itogo, 0, tempItogo, 0, kolvoResult - 1);
                    tempItogo [kolvoResult - 1] = numberAddS;
                    itogo = tempItogo;
                }        
                setTitle( I18N.getThisI18N().getViewStr("Founds: ").concat((new Integer(kolvoResult)).toString()));
    }
    
    public void commandAction(Command c, Displayable d)
    {
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        Display display = Display.getDisplay(myMIDlet);    
        
        if (c == backCmd)
        {
            display.setCurrent(SearchName.getInstance());
            instance = null; 
            return;
        }
        
       //   
       int iSelect = getSelectedIndex();  
       //         
       if (iSelect != -1)
       MainList.getInstance().setSelectedIndex(itogo [iSelect] + 1, true);       
        
       //   
       if (c == deleteCmd)
       {
            delete (iSelect);
            MainList.getInstance().commandAction(MainList.getInstance().deleteCmd, MainList.getInstance());                                
            if (size() != 0) 
            {
                setTitle( I18N.getThisI18N().getViewStr("Founds: ").concat((new Integer(size())).toString()));
                //       
                int [] tempI = new int [itogo.length - 1];
                System.arraycopy(itogo, 0, tempI, 0, iSelect);
                System.arraycopy(itogo, iSelect + 1, tempI, iSelect, itogo.length - iSelect - 1);
                itogo = tempI; 
                //    e,    
                for (int j = iSelect; j < itogo.length; j++)
                {
                    itogo [j] = itogo [j] - 1;
                }
                return;
            }            
       }
       //    
       display.setCurrent(((DisplayEkran)myMIDlet.backEkran.pop()).setParametr());
            
       if (c == renameCmd)
            MainList.getInstance().commandAction(MainList.getInstance().renameCmd, MainList.getInstance());                        
       
       if (c == List.SELECT_COMMAND)
            MainList.getInstance().commandAction(MainList.getInstance().SELECT_COMMAND, MainList.getInstance());                        
       
       instance = null; 
    }
  
    
}
