import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import java.io.*;
import javax.microedition.io.*;

public class SettingsList extends List implements CommandListener, Runnable
{
    private static SettingsList instance = null;
    private Command backCmd = new Command(I18N.getThisI18N().getViewStr("Back"), Command.BACK, 1); //  -     
    public boolean changeSet; //,    
    
    public SettingsList ()
    {   
        super(I18N.getThisI18N().getViewStr("Settings"), Choice.IMPLICIT);        
        append(I18N.getThisI18N().getViewStr("Sorting Method"), null);        
        append(I18N.getThisI18N().getViewStr("Password"), null);
        append(I18N.getThisI18N().getViewStr("AutoSave"), null);
        append(I18N.getThisI18N().getViewStr("General"), null);       
        append(I18N.getThisI18N().getViewStr("About"), null);        
        addCommand(backCmd);
        setCommandListener(this);
        changeSet = false;
        instance = this;        
    }
    
    public static SettingsList getInstance() 
    { 
        return instance; 
    }

    public void commandAction(Command c, Displayable d)
    {
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        Display display = Display.getDisplay(myMIDlet);    
        
        if (c == backCmd)
        {
            if (changeSet) //  
            { 
              //   
              (new Thread (this)).start();
              
              // ,       
              MiniPadRus.getInstance().inWGS = true;              
              new WaitGaugeScreen();
              
              display.setCurrent(WaitGaugeScreen.wgs); 
              (new Thread (WaitGaugeScreen.wgs)).start();              

            }
            else
            {
             //   ,     
             display.setCurrent(MainList.getInstance().setParametr());   
            }
        }
        
        //      
        String strIndex = getString(getSelectedIndex());
               
        //        
        if (c == List.SELECT_COMMAND) 
        {                 
                int kolvo;
                if (MiniPadRus.getInstance().str == null) kolvo = 0; else kolvo = MiniPadRus.getInstance().str.length;

                if (strIndex == I18N.getThisI18N().getViewStr("Password"))
            {
                display.setCurrent(new PwdForm());
            }    
           
            if (strIndex == I18N.getThisI18N().getViewStr("Sorting Method")) 
            {
                display.setCurrent(new SortingForm());
            }
                
            if (strIndex == I18N.getThisI18N().getViewStr("AutoSave")) 
            {
                display.setCurrent(new AutoSaveForm());
            }
                
            if (strIndex == I18N.getThisI18N().getViewStr("General")) 
            {
                display.setCurrent(new GeneralForm());
            }                
                
            //   " "
            if (strIndex == I18N.getThisI18N().getViewStr("About"))
            {   
                String titleAlert = I18N.getThisI18N().getViewStr("Entries: ").concat((new Integer(kolvo)).toString());
                Alert alertInfo = new Alert(titleAlert);
                alertInfo.setString(I18N.getThisI18N().getAlertText(0)); //   0          
                display.setCurrent(alertInfo, this);     
            }  
        }
       }
    
    public void run() 
    {
           try
            {   
            //   ,   ,    
            //  
            //      ,      
            (new DeleteRMS (MiniPadRus.getInstance().pwdRecName)).run();
           //         RMS  
            (new RmsIOThread (MiniPadRus.getInstance().pwdRecName, MiniPadRus.getInstance().pwd)).run();           
            
            //                     
     synchronized (MiniPadRus.getInstance().pwdRecName)                  
           {                  
            writeBooleanSet ();
            }
            }
            catch(Exception exception) { }
                       //  
            new EditFile(); // ,   ,      
    }
    
    private void writeBooleanSet () throws RecordStoreException, IOException
    {//    RMS   

       int boolByteSize = 16; //     - 16  :)
       boolean [] setBoolean = new boolean [boolByteSize];
       
       //    
       setBoolean [0] = MainList.sortByName;
       setBoolean [1] = MiniPadRus.getInstance().autoExit;
       setBoolean [2] = MiniPadRus.getInstance().autoSave;
       setBoolean [3] = MiniPadRus.getInstance().autoSaveByNumber;
       
       byte byteBool [] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //   0
       
       //0 - , 1 -     
       for (int i = 0; i < boolByteSize; i++)
           {
                if (setBoolean [i]) byteBool[i] = 1 ;
           }       
       
       RecordStore rs = null;
       
            try
            {  
                //      2 
                rs = RecordStore.openRecordStore(MiniPadRus.getInstance().pwdRecName, false);               
                rs.addRecord(byteBool, 0, boolByteSize);
           }
                finally
                {                  
                    if (rs != null) rs.closeRecordStore();                  
                }
                changeSet = false;
        }
    
}
