
import javax.microedition.lcdui.*;

//    
public class SortingForm extends Form implements CommandListener
{
    private Command cancelCmd = new Command(I18N.getThisI18N().getViewStr("Cancel"), Command.BACK, 2);
    private Command saveCmd = new Command(I18N.getThisI18N().getViewStr("Save"), Command.OK, 1);    
    private String [] sorterString = {I18N.getThisI18N().getViewStr("Sort by Name"), I18N.getThisI18N().getViewStr("Sort by Date")};
    private ChoiceGroup sorter = new ChoiceGroup(I18N.getThisI18N().getViewStr("Sorting Method"), Choice.EXCLUSIVE, sorterString, null);
    private StringItem stringItem = new StringItem (I18N.getThisI18N().getViewStr("Tips"), I18N.getThisI18N().getAlertText(6));    
    
    public SortingForm()
    {   
        //      
        super(I18N.getThisI18N().getViewStr("Settings"));
        sorter.setSelectedIndex(0, MainList.sortByName);
        sorter.setSelectedIndex(1, !MainList.sortByName);
        append(sorter);
        append (stringItem);
        addCommand(cancelCmd);
        addCommand(saveCmd);
        setCommandListener(this);    
    }
    
    public void commandAction(Command c, Displayable d) 
    {
        //  
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        //   
        Display display = Display.getDisplay(myMIDlet);  
         
        //  
        if (c == saveCmd)
        {
            SettingsList.getInstance().changeSet = true;
            if (sorter.getSelectedIndex() == 0) MainList.sortByName = true;
            else MainList.sortByName = false;
        }
        
        //    
        display.setCurrent(SettingsList.getInstance()); 
    }

}