
import javax.microedition.lcdui.*;

public class AutoSaveForm extends Form implements CommandListener, ItemStateListener
{
    private Command cancelCmd = new Command(I18N.getThisI18N().getViewStr("Cancel"), Command.BACK, 2); // 
    private Command saveCmd = new Command(I18N.getThisI18N().getViewStr("Save"), Command.OK, 1); // 
    private String [] extensionString = {I18N.getThisI18N().getViewStr("Yes")};
    private ChoiceGroup extension = new ChoiceGroup(I18N.getThisI18N().getViewStr("AutoSave"), Choice.MULTIPLE, extensionString, null);  //   ()
    private StringItem stringItem = new StringItem (I18N.getThisI18N().getViewStr("Tips"), I18N.getThisI18N().getAlertText(9));   
    private String [] namedString = {I18N.getThisI18N().getViewStr("Name + Number"), I18N.getThisI18N().getViewStr("Name + Date")};    
    private ChoiceGroup named = new ChoiceGroup(I18N.getThisI18N().getViewStr("Named Method"), Choice.EXCLUSIVE, namedString, null);
   
    public AutoSaveForm()
    {
        super(I18N.getThisI18N().getViewStr("Settings"));
        append (extension);
        //   
        named.setSelectedIndex(0, MiniPadRus.getInstance().autoSaveByNumber);
        named.setSelectedIndex(1, !MiniPadRus.getInstance().autoSaveByNumber);
        //  ,     
        if (MiniPadRus.getInstance().autoSave)
        {
        extension.setSelectedIndex(0, true);
        append (named);
        }
        append (stringItem);        
        addCommand(cancelCmd);
        addCommand(saveCmd);
        setCommandListener(this); 
        //      
        setItemStateListener(this);        
    }

    public void commandAction(Command c, Displayable d)
    {
        //  
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        //   
        Display display = Display.getDisplay(myMIDlet);  
         
        //  
        if (c == saveCmd)
        {
            SettingsList.getInstance().changeSet = true;
            //   
            if (extension.isSelected(0))
            {
                // 
                 MiniPadRus.getInstance().autoSave = true;
                 if (named.getSelectedIndex() == 0)
                     MiniPadRus.getInstance().autoSaveByNumber = true;
                 else
                     MiniPadRus.getInstance().autoSaveByNumber = false;
            }
            else 
            {
                 MiniPadRus.getInstance().autoSave = false;
             }
        }
        
        //    
        display.setCurrent(SettingsList.getInstance());         
    }
    
    public void itemStateChanged(Item item)
    {
        //     ,     
        if (item == extension)
            if (extension.isSelected(0))
        {
            insert (1, named);
        }
            else
        {
            delete(1);
        }
    }
    
}
