import java.util.Date;
import java.util.Calendar;
import java.util.TimeZone;

public class DateCalendar extends Calendar {
    
    private static DateCalendar dc = null;
    
  //    ,       
    public DateCalendar ()
    {
        this(System.currentTimeMillis());
    }
  //          long    
    public DateCalendar (long dateCalLong)   
    {
        super();
        dc = this;          
        setDC (dateCalLong);
    }
    
    //     
    public static DateCalendar setDC ()
    {
      return  setDC (System.currentTimeMillis());
    }
    
    //        
    public static DateCalendar setDC (long dateCalLong)
    {
       dc.setTime(new Date (dateCalLong));
       return dc;
    }
    
    //       String
    //    - +   
    public String myDateString (boolean withTime, boolean withSecond)
    {
    StringBuffer dateString = new StringBuffer (" ");        
    //       
    if (get(DATE) < 10)
    { dateString.append("0").append(get(DATE)).append("."); }
    else
    { dateString.append(get(DATE)).append("."); }
    if (get(MONTH) < 9)
    { dateString.append("0").append(get(MONTH)+1).append(".").append(get(YEAR)); }
    else
    { dateString.append(get(MONTH)+1).append(".").append(get(YEAR)); }   
    
//    ,  ?    
    if (withTime)
    {
        if (get(HOUR_OF_DAY) < 10)
        { dateString.append("  ").append("0").append(get(HOUR_OF_DAY)).append(":"); }
        else
        { dateString.append("  ").append(get(HOUR_OF_DAY)).append(":"); }
        if (get(MINUTE) < 10)
        { dateString.append("0").append(get(MINUTE)); }
        else
        { dateString.append(get(MINUTE)); }
        //   ,       
      if (withSecond) 
      {
        if (get(SECOND) < 10)
        { dateString.append(":").append("0").append(get(SECOND)); }
        else
        { dateString.append(":").append(get(SECOND)); }
      }
        
    }
    //   (  - 22 !!! ,  2 )
    return dateString.toString();
    }
  
}
