import javax.microedition.lcdui.*;
import java.util.Timer;
import java.util.TimerTask;

public class EditFile extends TextBox implements CommandListener, DisplayEkran
{    
    public static EditFile instance = null;
    private Command saveECmd; //  - 
    private Command cancelCmd; //  - 
    private Command lineCmd; //  
    private Command saveCCmd; //   
    private Command saveAsCmd; //   
    private int maxSize; //    
    public static Timer timer; //      
    public CalcSymbol calcer; //     
    private String rmsRecName; //   
    public boolean saveContinue = false; // ,      
    public boolean saveAs = false; // ,    
    private StringBuffer title; //    
    private String recordTemp; //        
    
   public EditFile()
   {
    super(I18N.getThisI18N().getViewStr("Edit"), "", 1, TextField.ANY); //    
    maxSize = setMaxSize(1024);
    if (!MiniPadRus.getInstance().autoSave)
    saveECmd = new Command(I18N.getThisI18N().getViewStr("Save"), Command.OK, 1); 
    else
    saveECmd = new Command(I18N.getThisI18N().getViewStr("Save (auto)"), Command.OK, 1);         
    addCommand(saveECmd);
    cancelCmd = new Command(I18N.getThisI18N().getViewStr("Cancel"), Command.CANCEL, 2);
    addCommand(cancelCmd);
    lineCmd = new Command(I18N.getThisI18N().getViewStr("Insert Line"), Command.SCREEN, 3);
    addCommand(lineCmd);
    saveCCmd = new Command(I18N.getThisI18N().getViewStr("Save&Continue"), Command.SCREEN, 4);    
    addCommand(saveCCmd);
    saveAsCmd = new Command(I18N.getThisI18N().getViewStr("Save As..."), Command.SCREEN, 5);    
    addCommand(saveAsCmd);
    setCommandListener(this);
    timer = new Timer ();
    title = new StringBuffer(I18N.getThisI18N().getViewStr("Edit"));
    instance = this;
   }
//     
    class CalcSymbol extends TimerTask
    {

    CalcSymbol()
        {
            super();
        }
//    : -   /    
    public void run()
        { 
            int tyu = getString().length();
            if (tyu < 100)
            setTitle((title.append(" ").append(tyu).append('/').append(maxSize)).toString());
            else
            setTitle((title.append(tyu).append('/').append(maxSize)).toString());    
            title.delete(4, title.length());
        }  
    }
 
   
    public static EditFile getInstance() 
    { 
        return instance; 
    }
       
    //     
    //       
       public Displayable setParametr()  
      {
      MiniPadRus.getInstance().badExitFlag = true;//        
      calcer = new CalcSymbol();      
      timer.schedule(calcer,500L,500L); //    
      
      return instance;
      } 
       
       //    ,   
      public Displayable setParametr(String si)
      {
      rmsRecName = si;    
      return setParametr();      
      }
 
      //       
      public Displayable setParametr(String s10, String s11)
      {
      rmsRecName = s10;
      recordTemp = s11;
      setString(s11);
      return setParametr();      
      }      
       
      //          
       public void exitEF()
       {  
        calcer.cancel(); //            
        setString(""); //     
        rmsRecName = null;
        recordTemp = null;
        setTitle(title.toString());
        MiniPadRus.getInstance().badExitFlag = false; //            
       }
       
       public void commandAction(Command c, Displayable d) 
       {
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        Display display = Display.getDisplay(myMIDlet);
    
    //  - ,     
    if (c == cancelCmd)
    {
        //    ,     
        display.setCurrent(((DisplayEkran)myMIDlet.backEkran.pop()).setParametr(recordTemp));
        exitEF();
    }
        
   //    
   if (c == lineCmd)
   {
        insert("\n", getCaretPosition());
   }
     
        //   
    if (c == saveECmd)
    {
        //        ,     
        if (rmsRecName == null && !MiniPadRus.getInstance().autoSave)
        {
            myMIDlet.backEkran.push(instance);
            display.setCurrent(FileNameBox.getInstance().setParametr(getString()));
            calcer.cancel(); //    
        }
            else
        {           
            //    ,    
            //      
            if (rmsRecName == null)
            {
                rmsRecName = FileNameBox.getInstance().giveOneWord(getString(), MiniPadRus.getInstance().autoSave);
                //  ,     
                if (rmsRecName.length() == 0) rmsRecName = I18N.getThisI18N().getViewStr("Empty");
                //  ,     
                //   ,      ,     
                if (MiniPadRus.getInstance().autoSaveByNumber)
                {                  
                   int jjj = 0;
                   String tmpName = (new String(rmsRecName));
                    
                   while (FileNameBox.getInstance().mayBeExist (tmpName, MiniPadRus.getInstance().str))
                   {
                        jjj++;
                        tmpName = (new String(rmsRecName)) + "  " + I18N.getThisI18N().getViewStr("#") + (new Integer(jjj)).toString();
                   }                    
                   rmsRecName = tmpName;    
                }
                //    
                myMIDlet.addStr(rmsRecName);                
            }
            //            
            display.setCurrent(((DisplayEkran)myMIDlet.backEkran.pop()).setParametr(rmsRecName, getString()));
            //     
            (new RmsIOThread (rmsRecName, getString())).start();
            exitEF();
        }
     }
        
    if (c == saveAsCmd)
    {
        myMIDlet.backEkran.push(instance);
        calcer.cancel(); //            
        //    
        if (rmsRecName == null)
        {
            display.setCurrent(FileNameBox.getInstance().setParametr(getString()));
        }
        else
        {
            saveAs = true;
            display.setCurrent(FileNameBox.getInstance().setParametr(rmsRecName, getString()));
        }
        
    }
        
    if (c == saveCCmd)
    {
        //     ,     
        if (rmsRecName == null)
        {
            saveContinue = true;
            myMIDlet.backEkran.push(instance);
            display.setCurrent(FileNameBox.getInstance().setParametr(getString()));             
            calcer.cancel(); //    
        }        
        else
        {  
            //     
            recordTemp = getString();
            //  
            (new RmsIOThread (rmsRecName, recordTemp)).start();
        }        
    }
       }
}
