import javax.microedition.lcdui.*;

//   
public class ExitForm extends Form implements CommandListener
{
    private Command yesCmd = new Command(I18N.getThisI18N().getViewStr("Yes"), Command.OK, 2);
    private Command noCmd = new Command(I18N.getThisI18N().getViewStr("No"), Command.CANCEL, 1);
    private String string = I18N.getThisI18N().getViewStr("Confirm on Exit").concat("\n "); //  
    private StringItem stringTips = new StringItem (I18N.getThisI18N().getViewStr("Tips"), I18N.getThisI18N().getAlertText(8));    
    
    public ExitForm()
    {
        super(I18N.getThisI18N().getViewStr("Are you sure?"));
        append (string);
        addCommand(yesCmd);
        addCommand(noCmd);
        append (stringTips);
        setCommandListener(this); 
    }

    public void commandAction(Command c, Displayable d)
    {
        //  
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        //   
        Display display = Display.getDisplay(myMIDlet);  
         
        //   / 
        if (c == noCmd)
        {        
        //   
        display.setCurrent(MainList.getInstance()); 
        }
        
        if (c == yesCmd)
        {
            myMIDlet.quit();
        }
        
    }
    
}
