
import javax.microedition.lcdui.*;

public class MainList extends List implements CommandListener, DisplayEkran
{
    private static MainList instance = null;
    private static Command newEntryCmd = new Command(I18N.getThisI18N().getViewStr("< New Entry >"), Command.SCREEN, 2); //  - " "      
    public static Command deleteCmd = new Command(I18N.getThisI18N().getViewStr("Delete"), Command.SCREEN, 3);
    public static Command renameCmd = new Command(I18N.getThisI18N().getViewStr("Rename"), Command.SCREEN, 4);    
    private static Command searchCmd = new Command(I18N.getThisI18N().getViewStr("Search"), Command.SCREEN, 5); //  - ""
    private static Command settingsCmd = new Command(I18N.getThisI18N().getViewStr("Settings"), Command.SCREEN, 7); //  - ""    
    private static Command exitCmd = new Command(I18N.getThisI18N().getViewStr("Exit"), Command.BACK, 9); //  - ""    
    public static boolean sortByName = true; //     
    public static int index = 0; //     
    
    public MainList ()
    {   
        super(I18N.getThisI18N().getViewStr("MiniPadRus"), Choice.IMPLICIT);        
        append(I18N.getThisI18N().getViewStr("  < New Entry >   "), null);
        addAllCommand();
        instance = this;        
    }
    
    public MainList (String [] aaa)
    { 
        super(I18N.getThisI18N().getViewStr("MiniPadRus"), Choice.IMPLICIT, aaa, null);            
        insert(0, I18N.getThisI18N().getViewStr("  < New Entry >   "), null);
        addAllCommand();
        setSelectedIndex(index, true);
        instance = this;
    }
    
    private void addAllCommand()
    {
        addCommand(newEntryCmd);
        addCommand(deleteCmd);
        addCommand(renameCmd);
        addCommand(searchCmd);
        addCommand(settingsCmd);
        addCommand(exitCmd);
        setCommandListener(this);
    }
    
     public static MainList getInstance() 
    { 
        return instance; 
    }    

     //    ,     
     //       
    public void plusIndex()
    {
        if (index < (size()-1)) index++; else index = 1;
        setSelectedIndex(index, true);
    }
   
    //    
    public void minusIndex()
    {
        if (index == 1) index = (size()-1); else index--;
        setSelectedIndex(index, true);
    }    

    //    
    public Displayable setParametr()
    {
        return instance;
    }
    
    //       (  Edit)
    public Displayable setParametr(String si)
    {
        MiniPadRus myMIDlet = MiniPadRus.getInstance(); 
        //       
        if (myMIDlet.str != null)
        {
        
        if (sortByName)
            myMIDlet.sortABC();
        else
            myMIDlet.sort123();    
        //    LIST 
        new MainList(myMIDlet.str);
        }
        return instance;
    }    
    
    //       
    public Displayable setParametr(String s10, String s11)
    {
        return setParametr("");
    }
    
    public void commandAction(Command c, Displayable d) 
    {
        //  
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        //   
        Display display = Display.getDisplay(myMIDlet); 
        
        //  
        if (c == exitCmd)
            if (MiniPadRus.getInstance().autoExit)
                 display.setCurrent(new ExitForm());
            else myMIDlet.quit() ;  
        
        //  
        if (c == newEntryCmd) 
        { 
            //                 
                myMIDlet.backEkran.push(instance);                 
            //         
                display.setCurrent(EditFile.getInstance().setParametr());        
        }
                
        if (c == searchCmd) 
        {
            //     ,   ,   
            if (myMIDlet.str == null || myMIDlet.str.length <= 2)
            {
                return;
            }
         //                 
         myMIDlet.backEkran.push(instance); 
         //     
         display.setCurrent(SearchName.getInstance());
        }
        
        //      
        index = getSelectedIndex();
        
        if (c == deleteCmd)
        {
            if (index == 0) return;
            
            delete(index);
           (new DeleteRMS (myMIDlet.str[index - 1])).start();
            myMIDlet.delString (index - 1);
        }
        
        //   
        if (c == List.SELECT_COMMAND) 
        { 
            //                 
                myMIDlet.backEkran.push(instance); 
                
            if (index == 0) 
            //         
                display.setCurrent(EditFile.getInstance().setParametr());
            else 
            {
            //           
                FileForm.getInstance().viewArrayInit(size(), index, myMIDlet.str[index -1]);
                display.setCurrent(FileForm.getInstance().setParametr());
            }
        }
        
         if (c == renameCmd)
        {             
            if (index == 0) return;
            
            //                 
                myMIDlet.backEkran.push(instance);  
            //         
                display.setCurrent(FileNameBox.getInstance().setParametr(myMIDlet.str[index -1], RmsIOThread.readRec(myMIDlet.str[index -1], index -1)));
        }
        
        //   ""
        if (c == settingsCmd)
        {   
            //        
                display.setCurrent(SettingsList.getInstance());
        }    
    }
    
}