
import javax.microedition.lcdui.*;

public class PwdForm extends Form implements CommandListener, ItemStateListener
{
    private Command cancelCmd = new Command(I18N.getThisI18N().getViewStr("Cancel"), Command.BACK, 2); // 
    private Command saveCmd = new Command(I18N.getThisI18N().getViewStr("Save"), Command.OK, 1); //  
    private TextField newField = new TextField(I18N.getThisI18N().getViewStr("New Password"), MiniPadRus.getInstance().pwd, 15, TextField.PASSWORD); //   
    private TextField confField = new TextField(I18N.getThisI18N().getViewStr("Confirm Password"), MiniPadRus.getInstance().pwd, 15, TextField.PASSWORD); //   
    private String [] extensionString = {I18N.getThisI18N().getViewStr("Yes")};
    private ChoiceGroup extension = new ChoiceGroup(I18N.getThisI18N().getViewStr("Use Password"), Choice.MULTIPLE, extensionString, null);  //   () -  
    private String newPwd ; //  
    private StringItem stringItem = new StringItem (I18N.getThisI18N().getViewStr("Tips"), I18N.getThisI18N().getAlertText(11));    
    
    public PwdForm()
    {
        super(I18N.getThisI18N().getViewStr("Settings"));
        append (extension);
        //   ,      
        if (MiniPadRus.getInstance().usePwd)
        {
            extension.setSelectedIndex(0, true);
            append (newField);
            append (confField);        
        }
        append (stringItem);
        addCommand(cancelCmd);
        addCommand(saveCmd);
        setCommandListener(this); 
        //      
        setItemStateListener(this);
    }

    public void commandAction(Command c, Displayable d)
    {
        //  
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        //   
        Display display = Display.getDisplay(myMIDlet);  
         
        //  
        if (c == saveCmd)
        {
            SettingsList.getInstance().changeSet = true;
            //   
            if (extension.isSelected(0))
            {
                //    ,      RMS
            newPwd = newField.getString();            
            if (newPwd.compareTo(confField.getString()) == 0 && newPwd.length() != 0)
            {
                //    
         MiniPadRus.getInstance().usePwd = true;
         MiniPadRus.getInstance().pwd = newPwd;
         
            }
            else 
            {
                //  ,   
                Alert alertInfo = new Alert(I18N.getThisI18N().getViewStr("Warning!"));
                alertInfo.setString(I18N.getThisI18N().getAlertText(7)); //   7          
                display.setCurrent(alertInfo, this);     
                return;
            }
            }
            else
                //   ,   ,
                if (MiniPadRus.getInstance().usePwd) 
                {
                 //    
                 MiniPadRus.getInstance().usePwd = false;
                 MiniPadRus.getInstance().pwd = "";
                }
        }
        
        //    
        display.setCurrent(SettingsList.getInstance());         
    }
    
    public void itemStateChanged(Item item)
    {
        //     ,     
        if (item == extension)
            if (extension.isSelected(0))
        {
            insert (1, newField);
            insert (2, confField);
        }
        else
        {
            delete(1);
            delete(1);
        }
    }
    
}
