import java.io.*;
import javax.microedition.io.*;
import javax.microedition.rms.*;
  
class RmsIOThread extends Thread
{
    private RecordStore rs = null; //     
    private String recName; //    
    private String saveStr; //   

   //    "",    
    RmsIOThread()
    {
        super();
        setPriority(MAX_PRIORITY); 
    }
    
//              
//    
    RmsIOThread(String sF, String sS)
    {
        super();
        setPriority(MIN_PRIORITY);
        recName = sF;
        saveStr = sS;
    }

    //     
    public void setParametr()
    {
        recName = "! backUp ! " + DateCalendar.setDC().myDateString(true, true);
        saveStr = EditFile.getInstance().getString();
    }

    //     1    ,      
  public static String readRec (String recRName, int jjj)
  {
      String recBody;
        //      ,  0  
        //    ,      
      //                           
            try
            { //    
   synchronized (recRName)
    {                    
               recBody = readFromRms(recRName, jjj);
     }
            }
            catch(Exception exceptionRec) {
                //    ,    
                recBody = (I18N.getThisI18N().getAlertText(1));
            }
            return recBody;
  }
  
  //   THROWS    
  private static String readFromRms (String recRName1, int kkk) throws RecordStoreException, IOException
  {   
      String recBody1;
      RecordStore rs1 = null;
               try
            {
                rs1 = RecordStore.openRecordStore(recRName1, false);            
                byte[] data = new byte[rs1.getRecordSize(1)];
                rs1.getRecord(1, data, 0);
                     
                ByteArrayInputStream bis = new ByteArrayInputStream(data);
                DataInputStream dataStream = new DataInputStream(bis);
                recBody1 = dataStream.readUTF();        
                MiniPadRus.getInstance().dat [kkk] = rs1.getLastModified();
             }
             finally
             {
               if (rs1 != null) rs1.closeRecordStore();
             }
             return recBody1;
  }
 
  //    RMS 
    private void writeRec () throws RecordStoreException, IOException
      {
               byte bDummy[] = {0, 0};
            try{  
                    rs = RecordStore.openRecordStore(recName, true);               
                    if(rs.getNumRecords() == 0)
                    rs.addRecord(bDummy, 0, 2);

                    //    
                    ByteArrayOutputStream bos = new ByteArrayOutputStream();
                    DataOutputStream dos = new DataOutputStream(bos);
                    dos.writeUTF(saveStr);
                                      
                    //    RMS
                   rs.setRecord(1,bos.toByteArray(),0,bos.size());
                }
                finally
                {                  
                    if (rs != null) rs.closeRecordStore();                  
                }
        }
        
        public void run()
        {
        //    ,      
      //                                 
           try
            {   
     synchronized (recName)
    {                  
            writeRec ();
     }
            }
            catch(Exception exception) {
            System.out.println(I18N.getThisI18N().getAlertText(3));
            }
        }

}