import javax.microedition.lcdui.*;

public class SearchName extends TextBox implements CommandListener

{
    private static SearchName instance = null;
    private Command okCmd; //  - 
    private Command cancelCmd; //  -     
    private String searchString; //   
    
    public SearchName()
    {
        super(I18N.getThisI18N().getViewStr("Search Name"), null, 30, TextField.ANY);
        cancelCmd = new Command(I18N.getThisI18N().getViewStr("View all Records"), Command.BACK, 2);
        addCommand(cancelCmd);
        okCmd = new Command(I18N.getThisI18N().getViewStr("Begin Search"), Command.OK, 1);
        addCommand(okCmd);        
        setCommandListener(this);
        instance = this;        
    }
    
    public static SearchName getInstance() 
    { 
        return instance; 
    }  

    private int searchExist(String str_, String[] strA_)
    {
        int yesFound = 0;
        String searchSmall = str_; //    
        String searchBig = str_; //       
        String subSearh; //   1 
        char ch = str_.charAt(0); //   
        if (str_.length() > 1) subSearh = str_.substring(1); else subSearh = "";
        
        //      ,  "",   
        //     -     
        if (ch >= 'A' && ch <= 'Z') //  
        {
            searchSmall = Character.toLowerCase(ch) + subSearh;
        }
        else
            if (ch >= 'a' && ch <= 'z') //  
            {
                searchBig = Character.toUpperCase(ch) + subSearh;
            }
            else
                if (ch >= 0x0410 && ch <= 0x042f) //  
                {
                    searchSmall = (char)(ch + 32) + subSearh;
                }   
                else
                    if (ch >= 0x0430 && ch <= 0x044f) //  
                    {
                        searchBig = (char)(ch - 32) + subSearh;
                    }
                    else
                        if (ch == '') 
                        {
                            searchSmall = ('') + subSearh;
                        }
                        else
                            if (ch == '') 
                            {
                                searchBig = ('') + subSearh;
                            }

        new SearchResult(); // ,    
        for (int i = 0; i < strA_.length; i++)
        {
            if (strA_[i].startsWith(searchBig) || strA_[i].startsWith(searchSmall))
            {
                yesFound++;
                SearchResult.getInstance().addNewResult(strA_[i], i, yesFound);
            }
        }
        
        return yesFound;
    }
    
    public void commandAction(Command c, Displayable d)
    {
        MiniPadRus myMIDlet = MiniPadRus.getInstance();
        Display display = Display.getDisplay(myMIDlet);    
        
            //    
            String searchString = getString();
            
            //      ,      
        if ((searchString.length() == 0) || (c == cancelCmd))
            {
                    display.setCurrent(((DisplayEkran)myMIDlet.backEkran.pop()).setParametr());
                    return;
            }        
        
        //    - 
        if (c == okCmd)
        {        
            //       ,    
            if ((MiniPadRus.getInstance().str != null) && searchExist(searchString, MiniPadRus.getInstance().str) == 0)
            {
                        Alert alertInfo = new Alert(searchString);
                        alertInfo.setString(I18N.getThisI18N().getAlertText(4));// + " " + Integer.toString(searchExist(searchString, MiniPadRus.getInstance().str)));
                        display.setCurrent(alertInfo, this);
                        return;
            }               
            //          
                display.setCurrent(SearchResult.getInstance());           
        }
    }
}